<template>
    <th class="ht-table__th" ref="th" :style="{minWidth: width + 'px', maxWidth: width + 'px', width: width + 'px'}" :data-width="width" data-direction="none" @click="sort">
        <slot></slot>
        <span v-if="sortDirection === 'up'">
            &#x25B2
        </span>
        <span v-if="sortDirection === 'down'">
            &#x25BC;
        </span>
    </th>
</template>

<script>
    export default {
        name: 'ht-th',
        props: {
            width: {
                type: Number,
                default: 50
            }
        },
        data() {
            return {
                name: '',
                sortDirection: ''
            };
        },
        mounted() {
            this.name = this.$refs.th.childNodes[1].data.toLowerCase();
            this.$watch(
                () => {
                    return this.$refs.attributes;
                },
                (val) => {
                    console.log(val);
                    alert('App $watch $refs.counter.i: ' + val);
                }
            );
        },
        methods: {
            sort() {
                let ownIndex = Array.prototype.indexOf.call(this.$refs.th.parentElement.children, this.$refs.th);
                this.sortDirection = this.$parent.sort(this.name, ownIndex);
            }
        },
        watch: {
            '$parent.sortActive': function (val) {
                if (val !== this.name) {
                    this.sortDirection = "none"
                }
            }
        }
    };
</script>

<style scoped>

</style>
